import ByteIO

BIT8SZ = 1
BIT16SZ = 2
BIT32SZ = 4
BIT64SZ = 8
MAXMSG = 10000
QIDSZ = BIT8SZ + BIT32SZ + BIT64SZ
# /* STATFIXLEN includes leading 16-bit count */
# /* The count, however, excludes itself; total size is BIT16SZ+count */
STATFIXLEN = BIT16SZ + QIDSZ + 5*BIT16SZ + 4*BIT32SZ + 1*BIT64SZ # /* amount of fixed lengt h data in a stat buffer */



class Dir :

	def D2M(self) :
		ns = len(self.name) + len(self.uid) + len(self.gid) + len(self.muid)
		ss = STATFIXLEN + ns
		bio = ByteIO.ByteIO(StringIO.StringIO())
		# dir entry size
		bio.PBIT16(ss - BIT16SZ + 2)
		# stat entry for dir
		bio.PBIT16(ss - BIT16SZ)
		bio.PBIT16(self.type)
		bio.PBIT32(self.dev)
		bio.pqid(self.qid)
		bio.PBIT32(self.mode)
		bio.PBIT32(self.atime)
		bio.PBIT32(self.mtime)
		bio.PBIT64(self.length)
		bio.pstring(self.name)
		bio.pstring(self.uid)
		bio.pstring(self.gid)
		bio.pstring(self.muid)

		
		return bio.getvalue()

		
