#!/usr/local/bin/python

import sys
import Fcall			
import Errors   			
import Fcall_GetT		
import ByteIO			
import Tmessage	


def stderr(txt) :
	sys.stderr.write(txt + "\n")
	sys.stderr.flush()
			
def isowner(user, fid) : 
	return user.id == fid.st.st_uid;


def get_call_func(fin, old9p=None) :
	

	if old9p == 1 :
		have = 0
	elif old9p == 0 :
		have = 0
	else :
		have = Fcall_GetT.readn(fin, 3)
 		if have != 3 :
			raise("couldn't read message") 

		# /* is it an old (9P1) message? */
		if 50 <= ord(Fcall_GetT.buffer[0]) and ord(Fcall_GetT.buffer[0]) <= 87 and (ord(Fcall_GetT.buffer[0])&1)==0 and ord(Fcall_GetT.buffer[0]) == 255 and ord(Fcall_GetT.buffer[1]) == 255 :
			old9p = 1
		else :
			old9p = 0

	Tmessage.old9p = old9p 	

	if old9p == 1 :
		call = Fcall_GetT.getfcallold
	else :
		call = Fcall_GetT.getfcallnew


	return (call, have)
	
authmethods = ['authrhosts' , 'authp9any', 'authnone']


old9p = None

i = 0
(fcall, have) = get_call_func(sys.stdin, old9p) 

while fcall(sys.stdin, have) :
	received = Tmessage.get_Tmessage(Fcall_GetT.buffer)

	log = file('/home/matt/u9fs/py/logs/%04d.Trx' % (i,), 'wb')
	log.write(Fcall_GetT.buffer)
	log.close()

	tx_bytes = received.get_Rmessage().as_bytes()

	log = file('/home/matt/u9fs/py/logs/%04d.Rtx' % (i,), 'wb')
	log.write(tx_bytes)
	log.close()

	i = i + 1
		
	sys.stdout.write(tx_bytes)
	sys.stdout.flush()

	Fcall_GetT.reset()
	have = 0