import stat
import os

QTDIR = 0x80
QTEXCL = 0x20	
def stderr(txt) :
	import sys
	sys.stderr.write(txt + "\n")
	sys.stderr.flush()

class Qid :
	def __init__ (self, filename='') :

		self.type = 0
		self.vers = 0
		self.path = 0

		if filename :
			st = os.stat(filename)
			if st :
				self.make_from_fid_stat(st)
		self.filename = filename

	def _print(self) :
		t = "Qid > t: %d  v: %d  p: %d" % (self.type, self.vers, self.path)
		stderr(t)

	def make_from_fid_stat(self, st) : ## this is brittle, what if target doesnt have same stat
		if st :
			self.type = 0
			if stat.S_ISDIR(st.st_mode) :
				self.type = self.type | QTDIR

			# 32bit
			self.vers =st.st_mtime | (st.st_size << 16)

			self.path = st.st_ino ## ignore -> | (st.st_dev << 32)

			return 1

		return 0

		#if stat.S_ISSPECIAL(st.st_mode) :
		 #	self.type = self.type | QTEXCL;

		# python has no S_ISSPECIAL so let's wreck the FS
